/*************************************************************************
 * ArtisticStylePlugin: Using Artistic Style at Qt Creator.              *
 * Copyright (C) 2010-2011  Lorenz Haas <lykurg@gmail.com>               *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *************************************************************************/

#ifndef ARTISTICSTYLEPLUGIN_H
#define ARTISTICSTYLEPLUGIN_H

#include "astyle/astyle.h"

#include <extensionsystem/iplugin.h>
namespace Core
{
  class IEditor;
}

#include <QAction>

namespace ArtisticStyle
{
  namespace Internal
  {
    class ArtisticStylePlugin : public ExtensionSystem::IPlugin
    {
        Q_OBJECT

      public:
        ArtisticStylePlugin();
        ~ArtisticStylePlugin();
        void extensionsInitialized();
        bool initialize(const QStringList& arguments, QString* errorString);
        void shutdown();

      private Q_SLOTS:
        void formatSource();
        void updateAction(Core::IEditor* editor);
        void updateFormatter();

      private:
        QAction* m_action;
        astyle::ASFormatter m_formatter;
        void configureFormatter(astyle::ASFormatter& formatter);
    };
  } // namespace Internal
} // namespace ArtisticStyle

#endif // ARTISTICSTYLEPLUGIN_H
